// This file is generated by kconfig_compiler_kf5 from videosettings.kcfg.
// All changes you do to this file will be lost.
#ifndef VIDEOSETTINGS_H
#define VIDEOSETTINGS_H

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

#include <QStandardPaths>

class VideoSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    static VideoSettings *self();
    ~VideoSettings() override;

    /**
      Set Screenshot format
    */
    static
    void setScreenshotFormat( const QString & v )
    {
      if (v != self()->mScreenshotFormat && !self()->isScreenshotFormatImmutable()) {
        self()->mScreenshotFormat = v;
        Q_EMIT self()->ScreenshotFormatChanged();
      }
    }

    Q_PROPERTY(QString screenshotFormat READ screenshotFormat WRITE setScreenshotFormat NOTIFY ScreenshotFormatChanged)
    Q_PROPERTY(bool isScreenshotFormatImmutable READ isScreenshotFormatImmutable CONSTANT)
    /**
      Get Screenshot format
    */
    static
    QString screenshotFormat()
    {
      return self()->mScreenshotFormat;
    }

    /**
      Is Screenshot format Immutable
    */
    static
    bool isScreenshotFormatImmutable()
    {
      return self()->isImmutable( QStringLiteral( "ScreenshotFormat" ) );
    }

    /**
      Get Screenshot format default value
    */
    static
    QString defaultScreenshotFormatValue()
    {
        return defaultScreenshotFormatValue_helper();
    }

    /**
      Set Screenshot template
    */
    static
    void setScreenshotTemplate( const QString & v )
    {
      if (v != self()->mScreenshotTemplate && !self()->isScreenshotTemplateImmutable()) {
        self()->mScreenshotTemplate = v;
        Q_EMIT self()->ScreenshotTemplateChanged();
      }
    }

    Q_PROPERTY(QString screenshotTemplate READ screenshotTemplate WRITE setScreenshotTemplate NOTIFY ScreenshotTemplateChanged)
    Q_PROPERTY(bool isScreenshotTemplateImmutable READ isScreenshotTemplateImmutable CONSTANT)
    /**
      Get Screenshot template
    */
    static
    QString screenshotTemplate()
    {
      return self()->mScreenshotTemplate;
    }

    /**
      Is Screenshot template Immutable
    */
    static
    bool isScreenshotTemplateImmutable()
    {
      return self()->isImmutable( QStringLiteral( "ScreenshotTemplate" ) );
    }

    /**
      Get Screenshot template default value
    */
    static
    QString defaultScreenshotTemplateValue()
    {
        return defaultScreenshotTemplateValue_helper();
    }


    enum {
      signalScreenshotFormatChanged = 0x1,
      signalScreenshotTemplateChanged = 0x2
    };

  Q_SIGNALS:
    void ScreenshotFormatChanged();

    void ScreenshotTemplateChanged();

  private:
    void itemChanged(quint64 flags);

  protected:
    VideoSettings(QObject *parent = nullptr);
    friend class VideoSettingsHelper;


    // Video
    QString mScreenshotFormat;
    static QString defaultScreenshotFormatValue_helper();
    QString mScreenshotTemplate;
    static QString defaultScreenshotTemplateValue_helper();

  private:
};

#endif

